__all__ = "LeftBanner"

from PySide2 import QtCore
from PySide2 import QtGui

from gm_qt_plugin.qt_plugin_accessor import QtPluginAccessor
from gm_qt_plugin.widgets.clickable_qlabel import ClickableQLabel
from gm_qt_plugin import qt_constants, qt_utils


class LeftBanner(ClickableQLabel, QtPluginAccessor):
    LEFT_BANNER_WIDTH = 229

    def __init__(self, plugin, parent=None):
        ClickableQLabel.__init__(self, parent=parent)
        QtPluginAccessor.__init__(self, plugin)

        user_interface = plugin.get_user_interface()
        pixmap = QtGui.QPixmap(user_interface.get_left_banner_image())

        self.setProperty(qt_constants.STYLE_PROPS.LEFT_BANNER, True)
        self.setPixmap(pixmap.scaledToWidth(LeftBanner.LEFT_BANNER_WIDTH,
                                            QtCore.Qt.SmoothTransformation))
        self.setFixedWidth(LeftBanner.LEFT_BANNER_WIDTH)
        self.setAlignment(QtCore.Qt.AlignCenter)
        self.setCursor(QtCore.Qt.PointingHandCursor)
        self.setOpenExternalLinks(True)
        self.clicked.connect(self.handle_clicked_signal)

    def handle_clicked_signal(self):
        qt_utils.open_url(self.get_plugin().get_user_interface().get_left_banner_link())
